Imports System.ComponentModel

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'DataGrid1
        '
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(0, 0)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(320, 273)
        Me.DataGrid1.TabIndex = 0
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(320, 273)
        Me.Controls.Add(Me.DataGrid1)
        Me.Name = "Form1"
        Me.Text = "howto_net_sort_dataset_collection"
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim m_Employees As IBindingList

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_Employees = New EmployeeList
        m_Employees.Add(New Employee("Bo", "Date"))
        m_Employees.Add(New Employee("Di", "Cherry"))
        m_Employees.Add(New Employee("Al", "Beech"))
        m_Employees.Add(New Employee("Cy", "Ash"))

        DataGrid1.DataSource = m_Employees
    End Sub
End Class

Public Class Employee
    Implements IEditableObject

    Private Structure EmployeeData
        Public FirstName As String
        Public LastName As String
    End Structure

    Private m_MyData As EmployeeData
    Private m_BackupData As EmployeeData
    Private m_Editing As Boolean
    Public Parent As EmployeeList

    Public Property FirstName() As String
        Get
            Return m_MyData.FirstName
        End Get
        Set(ByVal Value As String)
            m_MyData.FirstName = Value
        End Set
    End Property
    Public Property LastName() As String
        Get
            Return m_MyData.LastName
        End Get
        Set(ByVal Value As String)
            m_MyData.LastName = Value
        End Set
    End Property
    Public Sub New(ByVal first_name As String, ByVal last_name As String)
        m_MyData.FirstName = first_name
        m_MyData.LastName = last_name
    End Sub
    Public Sub New()
        m_MyData.FirstName = "<Unknown>"
        m_MyData.LastName = "<Unknown>"
    End Sub

    Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
        If Not m_Editing Then
            m_BackupData = m_MyData
            m_Editing = True
        End If
    End Sub

    Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
        If m_Editing Then
            m_MyData = m_BackupData
            m_Editing = False
        End If
    End Sub

    Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
        m_Editing = False
    End Sub

    Friend Property Parents() As EmployeeList
        Get
            Return Parent
        End Get
        Set(ByVal Value As EmployeeList)
            Parent = Value
        End Set
    End Property

    Private Sub OnCustomerChanged()
        If Not m_Editing And Not (Parent Is Nothing) Then
            Parent.EmployeeChanged(Me)
        End If
    End Sub 'OnCustomerChanged
End Class

Public Class EmployeeComparer
    Implements IComparer

    Private m_SortOnProperty As String
    Public Sub New(ByVal sort_on_property As String)
        m_SortOnProperty = sort_on_property
    End Sub

    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        Dim emp1 As Employee = DirectCast(x, Employee)
        Dim emp2 As Employee = DirectCast(y, Employee)
        Dim key1, key2 As String
        If m_SortOnProperty = "FirstName" Then
            key1 = emp1.FirstName & vbNullChar & emp1.LastName
            key2 = emp2.FirstName & vbNullChar & emp2.LastName
        Else
            key1 = emp1.LastName & vbNullChar & emp1.FirstName
            key2 = emp2.LastName & vbNullChar & emp2.FirstName
        End If
        Return String.Compare(key1, key2)
    End Function
End Class

Public Class EmployeeList
    Inherits CollectionBase
    Implements IBindingList

    Private Enum SortDir
        None
        Ascending
        Descending
    End Enum
    Private m_SortDir As SortDir = SortDir.None

    Private resetEvent As New ListChangedEventArgs(ListChangedType.Reset, -1)
    Private onListChanged1 As ListChangedEventHandler

    Public Sub LoadEmployees()
        Dim i_list As IList = CType(Me, IList)
        i_list.Add(New Employee("Al", "Archer"))
        i_list.Add(New Employee("Bo", "Bench"))
        i_list.Add(New Employee("Cy", "Cinder"))
        i_list.Add(New Employee("Di", "Diver"))
        OnListChanged(resetEvent)
    End Sub 'LoadCustomers

    ' Return an item at a position.
    Default Public Property Item(ByVal index As Integer) As Employee
        Get
            Return CType(List(index), Employee)
        End Get
        Set(ByVal Value As Employee)
            List(index) = Value
        End Set
    End Property

    ' Add an item to the  list.
    Public Function Add(ByVal value As Employee) As Integer
        Return List.Add(value)
    End Function 'Add

    ' Remove an item from the list by value.
    Public Sub Remove(ByVal value As Employee)
        List.Remove(value)
    End Sub 'Remove

    ' The list changed.
    Protected Overridable Sub OnListChanged(ByVal ev As ListChangedEventArgs)
        If Not (onListChanged1 Is Nothing) Then
            onListChanged1(Me, ev)
        End If
    End Sub 'OnListChanged

    ' Clear the list's Employee objects' Parent values.
    Protected Overrides Sub OnClear()
        Dim c As Employee
        For Each c In List
            c.Parent = Nothing
        Next c
    End Sub 'OnClear

    Protected Overrides Sub OnClearComplete()
        OnListChanged(resetEvent)
    End Sub 'OnClearComplete

    Protected Overrides Sub OnInsertComplete(ByVal index As Integer, ByVal value As Object)
        Dim c As Employee = CType(value, Employee)
        c.Parent = Me
        OnListChanged(New ListChangedEventArgs(ListChangedType.ItemAdded, index))
    End Sub 'OnInsertComplete

    Protected Overrides Sub OnRemoveComplete(ByVal index As Integer, ByVal value As Object)
        Dim c As Employee = CType(value, Employee)
        c.Parent = Me
        OnListChanged(New ListChangedEventArgs(ListChangedType.ItemDeleted, index))
    End Sub 'OnRemoveComplete

    Protected Overrides Sub OnSetComplete(ByVal index As Integer, ByVal oldValue As Object, ByVal newValue As Object)
        If oldValue <> newValue Then
            Dim oldcust As Employee = CType(oldValue, Employee)
            Dim newcust As Employee = CType(newValue, Employee)

            oldcust.Parent = Nothing
            newcust.Parent = Me

            OnListChanged(New ListChangedEventArgs(ListChangedType.ItemAdded, index))
        End If
    End Sub 'OnSetComplete

    ' Called by Employee when it changes.
    Friend Sub EmployeeChanged(ByVal cust As Employee)
        Dim index As Integer = List.IndexOf(cust)
        OnListChanged(New ListChangedEventArgs(ListChangedType.ItemChanged, index))
    End Sub 'EmployeeChanged

    ' Implements IBindingList.
    ReadOnly Property AllowEdit() As Boolean Implements IBindingList.AllowEdit
        Get
            Return True
        End Get
    End Property

    ReadOnly Property AllowNew() As Boolean Implements IBindingList.AllowNew
        Get
            Return True
        End Get
    End Property

    ReadOnly Property AllowRemove() As Boolean Implements IBindingList.AllowRemove
        Get
            Return True
        End Get
    End Property

    ReadOnly Property SupportsChangeNotification() As Boolean Implements IBindingList.SupportsChangeNotification
        Get
            Return True
        End Get
    End Property

    ReadOnly Property SupportsSearching() As Boolean Implements IBindingList.SupportsSearching
        Get
            Return False
        End Get
    End Property

    ReadOnly Property SupportsSorting() As Boolean Implements IBindingList.SupportsSorting
        Get
            Return True
        End Get
    End Property

    ' Events.
    Public Event ListChanged As ListChangedEventHandler Implements IBindingList.ListChanged

    ' Methods.
    Function AddNew() As Object Implements IBindingList.AddNew
        Dim c As New Employee
        List.Add(c)
        Return c
    End Function 'IBindingList.AddNew

    ' Unsupported properties.
    ReadOnly Property IsSorted() As Boolean Implements IBindingList.IsSorted
        Get
            Return (m_SortDir <> SortDir.None)
        End Get
    End Property

    ReadOnly Property SortDirection() As ListSortDirection Implements IBindingList.SortDirection
        Get
            If m_SortDir = SortDir.Descending Then Return ListSortDirection.Descending
            Return ListSortDirection.Ascending
        End Get
    End Property

    ReadOnly Property SortProperty() As PropertyDescriptor Implements IBindingList.SortProperty
        Get
            ' Creates a new collection and assign it the properties for Me.
            Dim properties As PropertyDescriptorCollection = TypeDescriptor.GetProperties(Me)
            Dim prop As PropertyDescriptor = properties.Find("SortProperty", False)
            Return prop
        End Get
    End Property

    ' Unsupported Methods.
    Sub AddIndex(ByVal prop As PropertyDescriptor) Implements IBindingList.AddIndex
        Throw New NotSupportedException("AddIndex")
    End Sub 'IBindingList.AddIndex

    Sub ApplySort(ByVal prop As PropertyDescriptor, ByVal direction As ListSortDirection) Implements IBindingList.ApplySort
        Dim emp_comparer As New EmployeeComparer(prop.Name)

        ' Sort ascending.
        InnerList.Sort(emp_comparer)

        ' Reverse if necessary.
        If direction = ListSortDirection.Descending Then InnerList.Reverse()
    End Sub 'IBindingList.ApplySort

    Function Find(ByVal prop As PropertyDescriptor, ByVal key As Object) As Integer Implements IBindingList.Find
        Throw New NotSupportedException("Find")
    End Function 'IBindingList.Find

    Sub RemoveIndex(ByVal prop As PropertyDescriptor) Implements IBindingList.RemoveIndex
        Throw New NotSupportedException("RemoveIndex")
    End Sub 'IBindingList.RemoveIndex

    Sub RemoveSort() Implements IBindingList.RemoveSort
        m_SortDir = SortDir.None
    End Sub 'IBindingList.RemoveSort
End Class 'EmployeesList
